"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Web3Container = void 0;

var _react = _interopRequireDefault(require("react"));

var _getWeb = _interopRequireDefault(require("./getWeb3"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Web3Container extends _react.default.Component {
  constructor(props) {
    super(props);
    this.state = {
      web3: null,
      accounts: null,
      contract: null
    };
  }

  async componentDidMount() {
    try {
      const web3 = await (0, _getWeb.default)();
      const accounts = this.fetchAccounts();
      this.setState({
        web3,
        accounts
      });
    } catch (error) {
      alert(`Failed to load web3, accounts. Check console for details.`);
    }
  }

  async fetchAccounts() {
    const web3 = await (0, _getWeb.default)();
    const accounts = await web3.eth.getAccounts();

    if (accounts.length === 0) {
      web3 && web3.currentProvider && web3.currentProvider.enable().then(accounts => this.setState({
        accounts
      })).catch(err => {
        this.setState({
          accountsError: err
        });
      });
    } else {
      return accounts;
    }
  }

  render() {
    const {
      web3,
      accounts
    } = this.state;
    return web3 && accounts.length > 0 ? this.props.render({
      web3,
      accounts
    }) : this.props.renderLoading();
  }

}

exports.Web3Container = Web3Container;